# rmg feb 2011
# copied from:
# .../mirc_python/FiberExplorerNew/shutterMatrix.py

'''
the import user command looks for .pythonrc.py and execute it
in our case .pythonrc.py gives acces to the modules from
$HOME/control/python/pythonLibs
'''

#import user
#import gtk
#import gobject
#import threading
import struct
import time
import numarray as na
#import itertools

import sys, os
myenv = {}
myenv.update(os.environ)
sys.path.append(myenv['HOME']+'/MIRC/mirc_python/pythonLibs')

### modules in pythonLibs
from socketLib import initSocketIteratePort2 as initSocket
#import IRCamLibs.IRCamCommands as ircc
#import IRCamLibs.camStructures

#import controlMountSocket

'''
A class that deals with the shutters
shutterConf: queries the current shutter configuration
shutterAction: open/close/query the status of a shutter
shutterStatus: calls shutterAction
shutterOpen: calls shutterAction
shutterClose: calls shutterAction
'''

def isStringLike(anobj):
        '''
        Check if anobj is a string
        '''
        try: anobj+''
        except: return False
        else: return True

def getKeyForValue( dict, valueToFind ):
    """Returns the key in dict with the given
    value. If no value is found returns None."""
    answer = None
    for key, value in dict.iteritems():
        if value == valueToFind: answer = key
    return answer

class shutterCommands:
    def __init__(self):
        self.host = '192.168.3.13'  #was wobble, now ople
        self.port = 4000
        self.NUMBER_SHUTTERS = 16   #/shutter/include/shutter.h
        self.MAX_CONFIGS = 64       #/include/chara_messages.h
    
        self.smessageType = {'OPEN_SHUTTER':   1100, \
                    'CLOSE_SHUTTER':  1101, \
                    'STATUS_SHUTTER': 1102, \
                    'SHUTTER_CONF':   1103}
    
        self.shutterStates = {'NOTHING': -1, \
                    'CLOSED':   0, \
                    'OPEN':     1, \
                    'MOVING':   2, \
                    'INSANE':   3}
    
        self.shutterCommands = {'SHUTTER_OPEN':        1, \
                    'SHUTTER_CLOSE':       2, \
                    'SHUTTER_STATUS':      3, \
                    'SHUTTER_MAX_COMMAND': 3}
    
        self.sockConf = initSocket(self.host, self.port)
        self.sockStatus = initSocket(self.host, self.port)
        self.sockOpen = initSocket(self.host, self.port)
        self.sockClose = initSocket(self.host, self.port)
        
        self.socketAction = {1100:self.sockOpen, 1101:self.sockClose, 1102:self.sockStatus, 1103:self.sockConf}

	# rmg feb2011
	self.currentStatus = {}

    def emptySock(self, sock):
        try: mess = sock.recv(32)
        except: 
            print "nothing to read"
            return 1
        else: 
            print "Read %d bytes" %(len(mess))
            return 0
    
    def shutterConf(self):
        smessageType = self.smessageType['SHUTTER_CONF']
        smessage_struct = struct.pack('HIs',smessageType,0,'')
        sock = self.socketAction[smessageType]
        if sock == None:
            print "socket frame failed to create"
        else:
            print "socket ok"
            self.sockConf.send(smessage_struct)
            print "sent data"
            while not self.readShutterConf(smessageType):
                time.sleep(0.1)
        sock.close()

    def readShutterConf(self,smessageType):
        sock = self.socketAction[smessageType]
        length = 0
        data = ''
        try: 
            print "trying messageType"
            while length < 2:
                message = sock.recv(2)
                l = len(message)
                length += l
                data += message
            #data = sock.recv(2)
        except: 
            print "failed to read messageType"
        else:
            messageType, = struct.unpack('H', data[0:2])
            print "message type = ", messageType
            if messageType != 1103:
                print "NOT A CONF MESSAGE"
                return 0
            else:
                print "A CONF MESSAGE"
                try: 
                    print "trying messageLength"
                    data = sock.recv(4)
                except: 
                    "failed to read messageLength"
                    return 0
                else:
                    messageLength, = struct.unpack('I', data)
                    print "message length = ", messageLength
                    length = 0
                    data = ''
                    try: 
                        print "trying messageData"
                        #data = sock.recv(messageLength)
                        while length < messageLength:
                            message = sock.recv(messageLength-length)
                            l = len(message)
                            length += l
                            data += message
                    except: 
                            "failed to read %d bytes of messageData" %(messageLength)
                            return 0
                    else:
                        self.messageType = messageType
                        self.messageLength = messageLength
                        self.numberOfConf, = struct.unpack('i', data[0:4])
                        self.name = data[4:85]
                        print "message type = ", self.messageType
                        print "message length = ", self.messageLength
                        print "number of configurations = ", self.numberOfConf 
                        print "name = ", self.name
                
                        posi = 85
                        self.shutterNames = []
                        for ndx in range(self.NUMBER_SHUTTERS-1):
                            self.shutterNames.append(data[posi+81*ndx:posi+81*(ndx+1)].strip('\x00'))
                        print "Shutter names = ", self.shutterNames
                
                        posi += 81*self.NUMBER_SHUTTERS
                        self.confNames = []
                        for ndx in range(self.numberOfConf):
                            self.confNames.append(data[posi+81*ndx:posi+81*(ndx+1)].strip('\x00'))
                        print "Configurations names = ", self.confNames
                
                        posi += 81*self.MAX_CONFIGS
                        self.conf = na.zeros((self.numberOfConf,self.NUMBER_SHUTTERS), type = na.Int8)
                        self.confStatus = [[]]*self.numberOfConf
                        for ndx in range(self.numberOfConf):
                            dt, = struct.unpack('%ds'%self.NUMBER_SHUTTERS, \
                                        data[posi+self.NUMBER_SHUTTERS*ndx:posi+self.NUMBER_SHUTTERS*(ndx+1)])
                            self.conf[ndx, :] = na.fromstring(dt, na.Int8, (self.NUMBER_SHUTTERS))
                            self.confStatus[ndx] = [getKeyForValue(self.shutterStates,x) for x in self.conf[ndx, :]]
                        print "configuration status = ", self.conf
                        print "configuration status ascii= ", self.confStatus
                        return 1
                        
    def shutterAction(self, shutter, action):
        #tests if action is the action name or number ex:'OPEN_SHUTTER' or 1100
        if isStringLike(action):
            smessageType = self.smessageType[action]
        else:
            smessageType = action
        #tests if shutter is the shutter name or number
        if isStringLike(shutter):
            shutter = self.shutterNames.index(shutter)
    
        self.sock = initSocket(self.host, self.port)
        sock = self.socketAction[smessageType]
        sshutter_status = struct.pack('BB',shutter,0)
    
        messType = struct.pack('H', smessageType)
        messSize = struct.pack('I', struct.calcsize('BB'))
        messData = sshutter_status
        print "message type = ", smessageType
        print "shutter = ", shutter
        if sock == None:
            print "socket frame failed to create"
        else:
            print "socket ok"
            sock.send(messType)
            sock.send(messSize)
            sock.send(messData)
            print "sent data"
            time.sleep(1.)
            while not self.readShutterStatus(shutter, smessageType):
                time.sleep(0.1)

    def readShutterStatus(self,shutter, smessageType):
        sock = self.socketAction[smessageType]
        length = 0
        data = ''
        try: 
            print "trying messageType"
            data = sock.recv(2)
        except: 
            print "failed to read messageType"
            return 0
        else:
            messageType, = struct.unpack('H', data[0:2])
            print "message type * = ", messageType
            if messageType != 1102:
                print "NOT A STATUS MESSAGE"
                return 0
            else:
                print "A STATUS MESSAGE"
                try: 
                    print "trying messageLength"
                    data = sock.recv(4)
                except: 
                    "failed to read messageLength"
                    return 0
                else:
                    messageLength, = struct.unpack('I', data)
                    print "message length = ", messageLength
                    try: 
                        print "trying messageData"
                        data = sock.recv(messageLength)
                    except: 
                        "failed to read %d bytes of messageData" %(messageLength)
                        return 0
                    else:
                        dt, =  struct.unpack('2s', data)
                        self.messageType = messageType
                        self.messageLength = messageLength
                        self.messageData = na.fromstring(dt, na.Int8, (2))
                        print "self.messageData = ", self.messageData 
                        if self.messageData[0] == shutter: 
                            self.currentStatus[shutter] = getKeyForValue(self.shutterStates, self.messageData[1])
                            print "shutter %d status = " %(shutter), self.currentStatus[shutter]
                            return 1
                        else: return 0
    def shutterStatus(self, shutter):
        self.shutterAction(shutter, 'STATUS_SHUTTER')

    def openShutter(self, shutter):
        self.shutterAction(shutter, 'OPEN_SHUTTER')

    def closeShutter(self, shutter):
        self.shutterAction(shutter, 'CLOSE_SHUTTER')

    def closeShutterSocket(self):
        #self.sockConf.close()
        self.sockStatus.close()
        self.sockOpen.close()
        self.sockClose.close()
