import socket
import common
import time
import struct
import numarray as na
import string

import os

from os import O_WRONLY, O_TRUNC, O_CREAT
from stat import S_IRUSR, S_IWUSR, S_IRGRP, S_IWGRP


## class sMessage:
##     def __init__(self):
##     	self.typ = 0
## 	self.length = 0
## 	self.data = ''
    
class filterControl:
    def __init__(self, portNumber, nmotors):
        """ constructor, setting initial variables """
        self.host = common.nport
        self.port = portNumber
        self.nmotors = nmotors
##         print "self.host = ", self.host
##         print "self.port = ", self.port

    def initSocket(self):
        self.sock = None
        print "self.host = ", self.host
        print "self.port = ", self.port
##         for res in socket.getaddrinfo(self.host, self.port, socket.AF_UNSPEC, socket.SOCK_STREAM):
##             af, socktype, proto, canonname, sa = res
        for res in socket.getaddrinfo(self.host, self.port, socket.AF_INET, socket.SOCK_STREAM):
            af, socktype, proto, canonname, sa = res
            try:
                self.sock = socket.socket(af, socktype, proto)
                self.sock.settimeout(60)
            except socket.error, msg:
                self.sock = None
                continue
            try:
                self.sock.connect(sa)
                self.fd = self.sock.fileno()
            except socket.error, msg:
                self.sock.close()
                self.sock = None
                continue
            break
        if self.sock is None:
            print 'could not open socket'

    def readLF(self):
# I assume socket is already open!
        dummy=""
        returnstring=""
        while (dummy != "\n"):
            try: dummy=self.sock.recv(1)
            except:
                print "no response from socket"
            else:
                returnstring=returnstring+dummy
        return returnstring

    def readCR(self):
# I assume socket is already open!
        dummy=""
        returnstring=""
        while (dummy != "\r"):
            try: dummy=self.sock.recv(1)
            except:
                print "no response from socket"
            else:
                returnstring=returnstring+dummy
        return returnstring
    def readNum(self,nchar):
        inbuf='' 
        length = 0
        while length < nchar:
            try: message = self.sock.recv(nchar-length)
            except:
                print "response time out waiting for %s" % nchar
                break
            else:
                length += len(message)
                inbuf += message
            return inbuf
        
    def initFilters(self,motorNum):
        self.initSocket()
        if self.sock == None:
            print "socket failed to create"
        else:
            self.sock.send("%sMN\r" % motorNum)
            print self.readCR()
            self.sock.send("%sMPA\r" % motorNum)
            print self.readCR()
            self.sock.send("%sSSD0\r" % motorNum)
            print self.readCR()
            self.sock.send("%sLD3\r" % motorNum)
            print self.readCR()
            self.sock.send("%sA0.5\r" % motorNum)
            print self.readCR()
            self.sock.send("%sV0.5\r" % motorNum)
            print self.readCR()
            self.sock.send("%sFSA1\r" % motorNum)
            print self.readCR()
            self.sock.send("%sOSB1\r" % motorNum)
            print self.readCR()
            self.sock.send("%sOSC1\r" % motorNum)
            print self.readCR()
            self.sock.send("%sGH+0.5\r" % motorNum)
            print self.readCR()
            self.sock.send("%sLF\r" % motorNum)
            print self.readCR()
            print self.readLF()
            self.sock.send("%sPZ\r" % motorNum)
            print self.readCR()
            self.sock.send("%sPR\r" % motorNum)
            print self.readCR()
            print self.readNum(13)
            self.sock.close()

    def homeFilters(self,motorNum):
	self.initSocket()
	if self.sock == None:
	    print "socket failed to create"
	else:
  	    self.sock.send("%sGH+0.5\r" % motorNum)
            print self.readCR()
            self.sock.send("%sLF\r" % motorNum)
            print self.readCR()
            print self.readLF()
	    self.sock.send("%sPR\r" % motorNum)
            print self.readCR()
            print self.readNum(13)
            self.sock.send("%sPZ\r" % motorNum)
            print self.readCR()
            self.sock.send("%sPR\r" % motorNum)
            print self.readCR()
            print self.readNum(13)
	    self.sock.close()

    def moveFilters(self,motorNum,encoderpos):
        self.initSocket()
        if self.sock == None:
            print "socket failed to create"
        else:
	    ser_string="%sD%s\r%sG\r" % (motorNum , str(encoderpos) , motorNum)
	    print ser_string
            self.sock.send(ser_string)
	    self.sock.send("%sLF\r" % motorNum)
            print self.readCR()
            print self.readLF()
            self.sock.send("%sPR\r" % motorNum)
            print self.readCR()
            print self.readNum(13)
# in one version of code, the IS came before the PR command
	    self.sock.send("%sIS\r" % motorNum)
            print self.readCR()
            self.sock.close()


