#!/usr/bin/env python
"""
An animated image
"""
import matplotlib
import pylab as pl
from matplotlib.backends.backend_gtk import FigureCanvasGTK as FigureCanvas
from matplotlib.figure import Figure
import numpy as np
import common

class AnimatedImage:
    def __init__(self):
        bcnb = 6
        plotnb = 4
        self.fig = Figure(figsize=(256,256))
        self.fig.subplots_adjust(left=0.05,right=0.98,hspace=0.,wspace=0.,top=0.98)
        self.a = {}
        self.b = {}
        self.c = {}
        self.d = {}
        self.intPlotA = 1
        self.intPlotB = 1
        self.intPlotC = 1
        self.intPlotD = 1
        self.lineA = {}
        self.lineB = {}
        self.lineC = {}
        self.lineD = {}
        for ndx, i in enumerate(range(1,bcnb+1)):
            self.a[ndx] = (self.fig.add_subplot(plotnb,bcnb,i))
            self.b[ndx] = (self.fig.add_subplot(plotnb,bcnb,i+6))
            self.c[ndx] = (self.fig.add_subplot(plotnb,bcnb,i+12))
            self.d[ndx] = (self.fig.add_subplot(plotnb,bcnb,i+18))
            if i==1:
                self.a[ndx].set_xticklabels([])
                self.b[ndx].set_xticklabels([])
                self.c[ndx].set_xticklabels([])
            if i>1:
                self.a[ndx].set_xticklabels([])
                self.a[ndx].set_yticklabels([])
                self.b[ndx].set_xticklabels([])
                self.b[ndx].set_yticklabels([])
                self.c[ndx].set_xticklabels([])
                self.c[ndx].set_yticklabels([])
                self.d[ndx].set_yticklabels([])
        self.canvas = FigureCanvas(self.fig)

    def updateFig(self):
        if common.liveDisplayStatus and common.dataFringeReady:
            if self.intPlotA:
                for ndx in range(bcnb):
                    if common.activeFringe[ndx]: self.lineA[ndx], = self.a[ndx].plot(common.fringeArr)
                self.intPlotA = 0
            else:
                for ndx in range(bcnb):
                    if common.activeFringe[ndx]: 
                        self.lineA[ndx].set_ydata(common.fringeArr)
                        self.a[ndx].dataLim.update_numerix(self.lineA[ndx].get_xdata(),self.lineA[ndx].get_ydata(),True)
                        self.a[ndx].autoscale_view()
            self.canvas.draw()   # redraw the canvas
            
        common.dataFringeReady = 0
        return True
