#!/usr/bin/env python
"""
An animated image
"""
import matplotlib
import pylab as pl
from matplotlib.backends.backend_gtk import FigureCanvasGTK as FigureCanvas
from matplotlib.figure import Figure
import numpy as np
import common
import random
import time


class AnimatedImage:
    def __init__(self):
        bcnb = common.nBL
        plotnb = 4
        self.fig = Figure(figsize=(256,256))
        self.fig.subplots_adjust(left=0.05,right=0.98,hspace=0.,wspace=0.,top=0.98)
        self.a = {}
        self.b = {}
        self.c = {}
        self.d = {}
        self.intPlotA = 1
        self.intPlotB = 1
        self.intPlotC = 1
        self.intPlotD = 1
        self.lineA = {}
        self.lineB = {}
        self.lineC = {}
        self.lineD = {}
        for ndx, i in enumerate(range(1,bcnb+1)):
            self.a[ndx] = (self.fig.add_subplot(plotnb,bcnb,i))
            self.b[ndx] = (self.fig.add_subplot(plotnb,bcnb,i+common.nBL))
            self.c[ndx] = (self.fig.add_subplot(plotnb,bcnb,i+2*common.nBL))
            self.d[ndx] = (self.fig.add_subplot(plotnb,bcnb,i+3*common.nBL))
            if i==1:
                self.a[ndx].set_xticklabels([])
                self.b[ndx].set_xticklabels([])
                self.c[ndx].set_xticklabels([])
            if i>1:
                self.a[ndx].set_xticklabels([])
                self.a[ndx].set_yticklabels([])
                self.b[ndx].set_xticklabels([])
                self.b[ndx].set_yticklabels([])
                self.c[ndx].set_xticklabels([])
                self.c[ndx].set_yticklabels([])
                self.d[ndx].set_yticklabels([])
        self.canvas = FigureCanvas(self.fig)

    def updateFig(self):
        if common.liveDisplayStatus and common.dataFluxReady:
            arr = np.zeros(common.nbpxFringe, dtype=np.float32)
            arr2 = np.zeros(common.nbpxFringe, dtype=np.float32)

            for ndx in range(common.nBL): 
                for npxFringe in range(common.nbpxFringe):
                    arr[npxFringe] = npxFringe
                    arr2[npxFringe] = random.random()
                    #arr2[npxFringe] = common.fringeArr[npxFringe][ndx]*random.random()

                if self.intPlotA:
                    print "HERE updateFig1"
                    #if common.activeFringe[ndx]:
                    self.lineA[ndx], = self.a[ndx].plot(arr, arr2)
                    if ndx==common.nBL-1: self.intPlotA = 0
                    print "HERE updateFig1b"
                else:
                    print "HERE updateFig2"
                    #if common.activeFringe[ndx]: 
                    self.lineA[ndx].set_ydata(arr2)
                    print "HERE updateFig2a"
                
                    self.a[ndx].update_datalim_numerix(self.lineA[ndx].get_xdata(),self.lineA[ndx].get_ydata())
                    self.a[ndx].autoscale_view()
                    print "HERE updateFig2b"
            self.canvas.draw()   # redraw the canvas
            time.sleep(.3)

        common.dataFluxReady = 0
        return True
