#!/usr/bin/env python

# 2010Aug04. JDM. modified MA version.  scales are in pixels now, not picomotro counts.
#                 and the program accounts for different number of pixels per pixel motion due to picomotor
#                 direction-dependent gain

# 2010Aug06  SK.  Merged in code from the CHAMPoffset.py tool in order to control the
#                 Zaber mounts
    
# example base.py
import pygtk
pygtk.require('2.0')
import mounts
import gtk
import icons
import picoData
import picoLowLevel
import numarray as PicoLib  
import sys	
import CHAMPPicoControl
import numpy
"""!!!This Code and its comments have been optimized for viewing at size 14 courier font!!!"""

from mapping import *
import controlMountSocket
import common
import time
import os.path



	
class home(picoLowLevel.PicoControl):
	
	# End program on close
	def delete_event(self, widget,event, data=None):					#Starts the definition for function that closes program	
		print "delete event occurred"							#Prints out a notification to command window
		self.window.destroy()								#Closes the open window of the main program
		return False									#Returning false does something, pygtk told me to do it

	def destroy(self, widget, data=None):							#Starts another function for closing the program
		print "destroy signal occurred"							#Again prints out a notification to command window
		gtk.main_quit									#Quits the underlieing gtk program
		self.window.destroy()								#Closes the open window of the main program
		sys.exit()									#End-all quit line, shuts down all running code of program
		return False									#Again, not sure, just doing what I was told
	
        #function for returning an arrow button
	def create_arrow_button(self,arrow_type, shadow_type):
		button = gtk.Button();
		arrow = gtk.Arrow(arrow_type, shadow_type);
		button.add(arrow)
		button.show()
		arrow.show()
		return button	

	
	def __init__(self):									#Here begins the main code for the GUI window
		
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)					#Creates new window for GUI and places it on top of the screen
		self.window.set_title("CHAMP Pixel Picomotor & CHAMPoffset Motor Control")	#Sets Window Title
		self.window.connect("delete_event", self.delete_event)				#Connects the x in corner of window to program ending function
		self.window.connect("destroy", self.destroy)					#Connects the x in corner of window to program ending function
		self.window.set_border_width(10)						#Sets the border width of the window		

		self.ycol = 'black'								#Color flags denote current color of arrow keys on control panel
		self.xcol = 'black'
		self.firsttime = True
		self.count = 1									#Count variable used later.						
		num = picoData.picoId.shape							#Variable is the number of picomotors stored in picoID within the picoData file
		names = picoData.picoId.field('picoId')
                plus_scales = picoData.picoScales.field('plus_scale')
    	 	minus_scales = picoData.picoScales.field('minus_scale')

 


################################################################################################################################################################
#################################################Contruct Power Tower Pico Control Tab#########################################################################
################################################################################################################################################################

		
		self.ypos=0
		self.xpos=0

        	#create a notebook to sit in the main window
        	self.notebook = gtk.Notebook()							#Creates a notebook widget which houses the tabs
       

        	PT_table = gtk.Table(8,8,False)							#Creates the table for the Power Tower control 8 rows, 8 cols, not homogeneous
        	PT_table.show()									#Makes the PT control table visible
        	PT_label = gtk.Label('Power Tower Picos')					#Sets the Label for the PT tab
        	self.notebook.append_page(PT_table,PT_label)					#Adds the PT table and label to the tab on the main window


        	self.zaber_table = gtk.Table(8,8,False)				         	#Creates the table for the I control 8 rows, 8 cols, not homogeneous
        	self.zaber_table.show()					         		#Makes the IC control table visible
        	self.zaber_label = gtk.Label('CHAMPoffset Motor')			       	#Sets the Label for the IC tab
        	self.notebook.append_page(self.zaber_table,self.zaber_label)			#Adds the IC table and label to the tab on the main window


        	#set tabs along the top
		self.notebook.set_tab_pos(gtk.POS_TOP)						#Links the tabs to the top of the notebook
        		

        	#attach the notebook to the window
        	self.window.add(self.notebook)							#Adds the notebook to the window
	

        	#show the notebook
        	self.notebook.show()								#Sets the notebook to visible
		self.window.show()								#Sets the window to visible
		
		#Now create the buttons for the picomotors in picoId, remember every 2 picomotors makes up 1 mount
		box = gtk.VBox(False, 2)							#Makes a box for buttons to be put on False denotes a non-expanding box, and 0 means
		box2 = gtk.VBox(False, 2)							#there will be no pixel padding around the box
		self.mount_buttons = []								#Creates the empty array for mount buttons
		offset = 1									#A counting variable to produce mount buttons
		switchbox = False								#Variable used to pack the mount buttons
		packbox = 1									#Variable denotes which box is currently being packed
		for i in range(num[0]/2):							#Iterates through the entries in picoId to create and name buttons
			
			self.mount_buttons.append(gtk.Button())					#Adds a new button to the mount buttons array
			self.mount_buttons[i].set_label(str(names[i+offset]))			#Labels the new button
			self.mount_buttons[i].connect("clicked", self.mounts_callback,i)	#Connects the new button with appropriate function when clicked
			if packbox == 1:							#the next two statement groups pack the new button into one of two boxes
				box.pack_start(self.mount_buttons[i], False, False, 0)
			elif packbox == 2:
				box2.pack_start(self.mount_buttons[i], False, False, 0)
			if (offset%3) == 0:							
				switchbox = True
			if switchbox == True:							#If the box is being switched, the next statements do it
				if packbox == 1:
					packbox = 2
				else:
					packbox = 1
				switchbox = False						#Change the switch setting back off
			self.mount_buttons[i].show()						#Make all the mount buttons visible
			offset = offset + 1							#Offset increases to only make buttons for every other entry in picoI

		
		boxtable = gtk.Table(2,1,False)
		boxtable.attach(box,0,1,0,1,gtk.FILL,0,2,2)					#Attach box to the table
		boxtable.attach(box2,1,2,0,1,gtk.FILL,0,2,2)					#Attach box2 to the table 
		self.frame11 = gtk.Frame("Available Picomotors")					#Creates a labeled frame
		self.frame11.add(boxtable)							#Adds a labeled frame around the text box
		PT_table.attach(self.frame11, 0,1,0,3, gtk.FILL,0,2,2) 		#Attaches entry and frame to the control panel
		self.frame11.show()		
		box.show()									#Makes box visible
		box2.show()									#Makes box2 visible
		boxtable.show()

		
		# Create Control buttons
		self.control_buttons = self.create_control_buttons()				#Calls function that creates the arrow buttons
		self.control_panel = gtk.Table(6,4, False)					#Creates the control panel, a table of 6 rows, 4 cols


		# Up Arrow of control panel
		self.control_panel.attach(self.control_buttons[2], 2,3,0,1, 0,0,0,0) 		#Attaches arrow button to control panel
		self.control_buttons[2].connect("clicked", self.push_to_move_callback,'up')	#Connects a click to the move callback
		self.control_buttons[2].add(self.upblack)						#Adds a black arrow icon to this button
		self.upblack.show()								#Makes the arrow icon visible
		self.control_buttons[2].show()

		""" All other arrow button definitions follow the same format as the one above unless otherwise noted."""

		# Down Arrow of control panel
		self.control_panel.attach(self.control_buttons[3], 2,3,2,3, 0,0,0,0)		
		self.control_buttons[3].connect("clicked", self.push_to_move_callback,'down')
		self.control_buttons[3].add(self.downblack)
		self.downblack.show()
		self.control_buttons[3].show()

		# Right Arrow of control panel
		self.control_panel.attach(self.control_buttons[1],3,4,1,2,0,0,0,0)				
		self.control_buttons[1].connect("clicked", self.push_to_move_callback,'right')
		self.control_buttons[1].add(self.rightblack)
		self.rightblack.show()
		self.control_buttons[1].show()

		# Left Arrow of control panel
		self.control_panel.attach(self.control_buttons[0], 1,2,1,2, 0,0,0,0)		
		self.control_buttons[0].connect("clicked", self.push_to_move_callback,'left')
		self.control_buttons[0].add(self.leftblack)
		self.leftblack.show()
		self.control_buttons[0].show()



		self.entry = []									#Creates an empty array for stuff on the contol panel
		self.entrySteps = []								#Creates another empty array for stuff

		# Label for selected Picomotor
		self.entry.append(gtk.Label(picoData.label))					#Adds a text entry box to the array 
		self.entry[0].set_size_request(80,20)						#Sets the size of the text box to 80pts wide 20pts high
		self.entry[0].show()
		self.frame0 = gtk.Frame("Active Picomotor")					#Creates a labeled frame
		self.frame0.add(self.entry[0])							#Adds a labeled frame around the text box
		self.control_panel.attach(self.frame0, 0,1,0,1, gtk.FILL,0,2,2) 		#Attaches entry and frame to the control panel
		self.frame0.show()


		# Step Size on X Axis
		self.entry.append(gtk.Entry())							#Adds a text entry box to the array
		self.entry[1].set_size_request(60,20)						#Sets the size of the text box to 60pts by 20pts
		self.entry[1].show()
		self.entry[1].set_editable(True)						#Sets the text box so that it can be edited
		self.frame1 = gtk.Frame("X Axis Step Size")					#Creates a labled frame
		self.frame1.add(self.entry[1])							#Adds the labeled frame around the text box
		self.control_panel.attach(self.frame1, 0,1,4,5, gtk.FILL,gtk.FILL,2,2)		#Attaches pair to the control panel
		#self.entry[1].connect("activate",self.update_step_callback, 'X')		#Connects a return keystroke to an update function
		#self.entry[1].connect("changed", self.changed, 'X')				#Also connects the box to a function that checks changes in the text box
		self.frame1.show()


		# Step Size on Y Axis
		self.entry.append(gtk.Entry())							#Adds another text entry to the array
		self.entry[2].set_size_request(60,20)						#Sets the size of the text box to 60pts by 20pts
		self.entry[2].show()
		self.entry[2].set_editable(True)						#Sets the text box so that it can be edited
		self.frame2 = gtk.Frame("Y Axis Step Size")					#Creates a labeled frame
		self.frame2.add(self.entry[2])							#Adds the labeled frame around the text box
		self.control_panel.attach(self.frame2, 0,1,5,6, gtk.FILL,0,2,2) 		#Attaches the pair to the control panel
		#self.entry[2].connect("activate",self.update_step_callback, 'Y')		#Connects and a return keystroke in the text entry to 											a function that updates the step size, passing in the 											axis on which the change is made
		#self.entry[2].connect("changed", self.changed, 'Y')				#Also connects the box to a function, this one 											monitors changes made without an enter keystroke, 											passing in the axis on which the change is made
		self.frame2.show()


		# Step Size Double Button
		self.double_button = gtk.Button("2X Step Size")				 	#Creates a new button for doubling step size
		self.control_panel.attach(self.double_button, 0,1,3,4,gtk.FILL,0,2,2)	 	#Attaches button to control panel
		self.double_button.show()						 	#Makes the button visible
		self.double_button.connect("clicked",self.step_button_callback, 'double')	#Attaches a click to the callback handling 								      				 	the change

		# Step Size Half Button
		self.half_button = gtk.Button("1/2X Step Size")				 	#Creates a new button for halving step size
		self.control_panel.attach(self.half_button, 0,1,2,3,gtk.FILL,0,2,2)	 	#Attaches button to control panel
		self.half_button.show()							 	#Makes the button visible
		self.half_button.connect("clicked",self.step_button_callback, 'half')	 	#Attaches a click to the callback handling 												 	the change
		
		# y position indicator
		self.entry.append(gtk.Label(str(self.ypos)))					#Adds an uneditable label to the array and puts the currently 													stored value of the y position in the label
		self.entry[3].set_size_request(80,20)						#Sets the size of the label to 80pts by 20pts
		self.entry[3].show()
		self.frame3 = gtk.Frame("Y Position")						#Creates a labeled frame for the label
		self.frame3.add(self.entry[3])							#Attaches the labeled frame to the label
		self.control_panel.attach(self.frame3, 2,4,5,6, 0,0,2,2)			#Attaches the pair to the control panel
		self.frame3.show()


		# x position indicator
		self.entry.append(gtk.Label(str(self.xpos)))					#Adds an uneditable label to the array and puts the currently 													stored value of the y position in the label
		self.entry[4].set_size_request(80,20)						#Sets the size of the label to 80pts by 20pts
		self.entry[4].show()
		self.frame4 = gtk.Frame("X Position")						#Creates a labeled frame for the label
		self.frame4.add(self.entry[4])							#Attaches the labeledt frame to the label
		self.control_panel.attach(self.frame4, 2,4,4,5, 0,0,2,2)			#Attaches the pair to the control panel
		self.frame4.show()

		# Status Bar
		self.statusbar = gtk.Label("Status: No Errors ")				#Creates the status bar that shows errors
		self.control_panel.attach(self.statusbar,0,6,6,7,0,gtk.FILL,0,0)		#Attaches the status bar to the control panel
		self.statusbar.show()								#Makes the status bar visible


		# Zeroing menu
		self.zerobar = gtk.MenuBar()							#Creates the zeroing  menu for the currently selected pico
		subzero = gtk.Menu()								#Creates the sub menu for zeroing
		zeroitem = gtk.MenuItem("Zero")							#Creates the top level menu view
        	all = gtk.MenuItem("All")							#Creates the all option for the zeroing menu
        	x = gtk.MenuItem("X axis")							#Creates the x axis option for the zeroing menu
		y = gtk.MenuItem("Y axis")							#Creates the y axis option for the zeroing menu
		subzero.append(all)								#Adds the all option to the sub menu
		subzero.append(x)								#Adds the x option to the sub menu
		subzero.append(y)								#Adds the y option to the sub menu
		zeroitem.set_submenu(subzero)							#Sets the  sub menu as a 'sub_menu'
		self.zerobar.append(zeroitem)							#Adds the'sub_menu' to the menu bar for zeroing
		self.control_panel.attach(self.zerobar, 2,3,3,4,0,0,0,0)			#Attaches the zeroing menu to the control panel
		self.zerobar.show() 								#Makes the zeroing menu visible
		
		# Zeroing menu Callbacks
		#all.connect("activate",self.zero_callback, 'all')				#Attaches the all zeroing option to the zeroing callback and 													passes in that all has been selected
		#x.connect("activate",self.zero_callback, 'x')					#Attaches the  x axis option to the zeroing callback and 													passes in that x has been selected
		#y.connect("activate",self.zero_callback, 'y')					#Attaches the y axis option to the zeroing callback and 												passes in that x has been selected

		#PT_table.attach(self.control_panel,3,4,0,1,gtk.FILL,gtk.FILL,0,0)			#Attaches the table to the control panel, making the control 													panel work

		self.frame10 = gtk.Frame("Picomotor Controls")					#Creates a labeled frame
		self.frame10.add(self.control_panel)							#Adds a labeled frame around the text box
		PT_table.attach(self.frame10, 3,4,0,1, gtk.EXPAND,gtk.SHRINK,2,2) 		#Attaches entry and frame to the control panel
		self.frame10.show()


		self.control_panel.show()






		# Create Control buttons
		self.control_buttons = self.create_control_buttons()				#Calls function that creates the arrow buttons
		self.control_panel2 = gtk.Table(6,4, False)			




		# Step Size Double Button
		self.double_button = gtk.Button("2X Step Size")				 	#Creates a new button for doubling step size
		self.control_panel2.attach(self.double_button, 0,1,2,3,gtk.FILL,0,2,2)	 	#Attaches button to control panel
		self.double_button.show()						 	#Makes the button visible
		#self.double_button.connect("clicked",self.step_button_callback, 'double')	#Attaches a click to the callback handling 								      				 	the change

		# Step Size Half Button
		self.half_button = gtk.Button("1/2X Step Size")				 	#Creates a new button for halving step size
		self.control_panel2.attach(self.half_button, 0,1,1,2,gtk.FILL,0,2,2)	 	#Attaches button to control panel
		self.half_button.show()							 	#Makes the button visible
		#self.half_button.connect("clicked",self.step_button_callback, 'half')	 	#Attaches a click to the callback handling 												 	the change
		
		#  position indicator
		#self.entry.append(gtk.Label(str(self.ypos)))					#Adds an uneditable label to the array and puts the currently 													stored value of the y position in the label
		#self.entry[5].set_size_request(80,20)						#Sets the size of the label to 80pts by 20pts
		#self.entry[5].show()
		#self.frame5 = gtk.Frame("Position")						#Creates a labeled frame for the label
		#self.frame5.add(self.entry[3])							#Attaches the labeled frame to the label
		#self.control_panel2.attach(self.frame3, 5,6,2,3, 0,0,2,2)			#Attaches the pair to the control panel
		#self.frame5.show()

		#print self.entry
		# Step Size on X Axis
		#self.entry.append(gtk.Entry())							#Adds a text entry box to the array
		#self.entry[6].set_size_request(60,20)						#Sets the size of the text box to 60pts by 20pts
		#self.entry[6].show()
		#self.entry[6].set_editable(True)						#Sets the text box so that it can be edited
		#self.frame1 = gtk.Frame("Step Size")						#Creates a labled frame
		#self.frame1.add(self.entry[6])							#Adds the labeled frame around the text box
		#self.control_panel2.attach(self.frame1, 0,1,0,1, gtk.FILL,gtk.FILL,2,2)		#Attaches pair to the control panel
		#self.entry[6].connect("activate",self.update_step_callback, 'X')		#Connects a return keystroke to an update function
		#self.entry[6].connect("changed", self.changed, 'X')				#Also connects the box to a function that checks changes in the text box
		#self.frame1.show()



		#Creates the control panel, a table of 6 rows, 4 cols


		
		"""self.control_panel2.attach(self.control_buttons[4],5,6,0,1, 0,0,0,0) 		#Attaches arrow button to control panel
		#self.control_buttons[4].connect("clicked", self.push_to_move_callback,'up')	#Connects a click to the move callback
		self.control_buttons[4].add(self.plusblack)						#Adds a black arrow icon to this button
		self.control_buttons[4].show()

		self.plusblack.show()								#Makes the arrow icon visible
		#self.control_buttons[4].show()

		
		self.control_panel2.attach(self.control_buttons[5], 5,6,1,2, 0,0,0,0)		
		#self.control_buttons[5].connect("clicked", self.push_to_move_callback,'down')
		self.control_buttons[5].add(self.minusblack)
		self.minusblack.show()
		self.control_buttons[5].show()



		self.frame12 = gtk.Frame("Zaber Controls")					#Creates a labeled frame
		self.frame12.add(self.control_panel2)							#Adds a labeled frame around the text box
		PT_table.attach(self.frame12, 3,4,1,2, gtk.FILL,gtk.EXPAND,2,2) 		#Attaches entry and frame to the control panel
		self.frame12.show()
		self.control_panel2.show()
"""



################################################################################################################################################################
#################################################CHAMPoffset Functions#########################################################################
################################################################################################################################################################


		print 'Now trying CHAMPoffset (Zaber) mounts....'
		self.zab = common.zab
		time.sleep(.3)
		self.nzaber = self.zab.renumber()
		print "self.nzaber = ", self.nzaber

		self.all_stage=[]
		
		
	#############################################
        
        ######## CHAMPoffset ##########
		
		self.m = self.nzaber
		print self.m 
		for i in range(6):
			self.zab.command(i+1,44,210000)

                #add command to limit actuators
	
	        self.actuator = 1
				
                #joystick for moving mirror in and out
		
		self.zaber_joystick_table = gtk.Table(5,3,True)
		self.zaber_in_z_button = []
		self.zaber_out_z_button = []
		for i in range(6):
			if i<5:
				j=i
			else:
				j=i+1
			self.zaber_in_z_button.append(self.create_arrow_button(gtk.ARROW_UP, gtk.SHADOW_IN))
			self.zaber_in_z_button[i].connect('clicked', self.zaber_move, 'IN', i+1)
			self.zaber_joystick_table.attach(self.zaber_in_z_button[i],j+1,j+2,0,1,\
							 xoptions = False,\
							 yoptions = False,xpadding = 2, ypadding = 2)
			self.zaber_out_z_button.append(self.create_arrow_button(gtk.ARROW_DOWN, gtk.SHADOW_IN))
			self.zaber_out_z_button[i].connect('clicked',self.zaber_move,'OUT', i+1)
			self.zaber_joystick_table.attach(self.zaber_out_z_button[i],j+1,j+2,2,3,\
							 xoptions = False,yoptions = False,xpadding = 2, \
							 ypadding = 2)

		#add labels to joystick buttons
		self.zaber_z_label = []
		lbl = ['IR1', 'IR2', 'IR3', 'IR4', 'IR5', 'BC']
		for i in range(len(lbl)):
			self.zaber_z_label.append(gtk.Label(lbl[i]))
			self.zaber_z_label[i].show()
			if i<5:
				j=i
			else:
				j=i+1
			self.zaber_joystick_table.attach(self.zaber_z_label[i],j+1,j+2,1,2,xoptions = False,\
							 yoptions = False,xpadding = 2, ypadding = 2)
        
		self.zaber_jst_label = []
		lbl = ['OPD -', 'OPD +']
		xy = [[0,1,0,1], [0,1,2,3]]
		for i in range(len(lbl)):
			self.zaber_jst_label.append(gtk.Label(lbl[i]))
			self.zaber_jst_label[i].show()
			self.zaber_joystick_table.attach(self.zaber_jst_label[i],xy[i][0],xy[i][1],xy[i][2],\
							 xy[i][3],xoptions = False,\
							 yoptions = False,xpadding = 2, ypadding = 2)

                #add menus:
		self.zaber_menu_bar = []
		self.zaber_menu_name = []
		self.zaber_menu = []
		self.zaber_menu_item_home = []
		self.zaber_menu_item_good = []
		self.zaber_menu_item_other = []
		act = [1, 2, 3, 4, 5, 6]
		for i in range(6):
			if i<5:
				j=i
			else:
				j=i+1
			self.zaber_menu_bar.append(gtk.MenuBar())
			self.zaber_menu_bar[i].show()
			self.zaber_menu_name.append(gtk.MenuItem('Menu'))
			self.zaber_menu_name[i].show()
			self.zaber_menu.append(gtk.Menu())
			self.zaber_menu_item_home.append(gtk.MenuItem('Home'))
			self.zaber_menu_item_good.append(gtk.MenuItem('Good'))
			self.zaber_menu_item_other.append(gtk.MenuItem('Other'))
			self.zaber_menu_item_home[i].show()
			self.zaber_menu_item_good[i].show()
			self.zaber_menu_item_other[i].show()
			self.zaber_menu[i].append(self.zaber_menu_item_home[i])
			self.zaber_menu[i].append(self.zaber_menu_item_good[i])
			self.zaber_menu[i].append(self.zaber_menu_item_other[i])
			self.zaber_menu_item_home[i].connect("activate", self.zaber_home, act[i])
			self.zaber_menu_item_good[i].connect_object("activate", self.zaber_read_file, act[i], 'good.eal')
			self.zaber_menu_item_other[i].connect_object("activate", self.zaber_read_file, act[i], 'other.eal')
			self.zaber_menu_name[i].set_submenu(self.zaber_menu[i])
			self.zaber_menu_bar[i].append(self.zaber_menu_name[i])
			self.zaber_joystick_table.attach(self.zaber_menu_bar[i],\
							 j+1,j+2,3,4, xoptions = False,\
							 yoptions = False,xpadding = 2, ypadding = 2)
			self.zaber_joystick_table.show()
        
                #attach joystick table to notebook table
		self.zaber_table.attach(self.zaber_joystick_table,0,2,0,1,xoptions = False|True,\
					yoptions = False|True)		
        
                #now for z, left button does 0.1 microns, right does 10
		self.zaber_z_adjustment = gtk.Adjustment(value=10., lower=0.1, upper=500.0, \
							 step_incr=0.1, page_incr=5, page_size=0)
		self.zaber_z_spin_button = gtk.SpinButton(adjustment=self.zaber_z_adjustment, \
							  climb_rate=0.0, digits=1)
                #constrain entered values to numbers (not letters)
		self.zaber_z_spin_button.set_numeric(numeric=True)
                #do not wrap from 100 microns to 0.
		self.zaber_z_spin_button.set_wrap(wrap=False)
                #if user enters a non-multiple of 0.1, the number is rounded off
		self.zaber_z_spin_button.set_snap_to_ticks(snap_to_ticks=True)
                #only change the value entered if it is a number within range
		self.zaber_z_spin_button.set_update_policy(gtk.UPDATE_IF_VALID)
		self.zaber_z_spin_button.show()
		
                #toggle switch to automatically view cross section
		self.zaber_spin_button_table = gtk.Table(3,3,False)
        
                #add spin buttons and lables to spin_table
		self.zaber_spin_button_table.attach(self.zaber_z_spin_button,1,2,0,1,xpadding = 2, \
						    ypadding = 2)
        
		self.zaber_z_spin_label = gtk.Label('Z step size:')
		self.zaber_z_spin_label.show()
		self.zaber_microns_label = gtk.Label('microns')
		self.zaber_microns_label.show()
		self.zaber_spin_button_table.attach(self.zaber_z_spin_label,0,1,0,1,xpadding = 2, \
						    ypadding = 2)
		self.zaber_spin_button_table.attach(self.zaber_microns_label,2,3,0,1,xpadding = 2,\
						    ypadding = 2)
		self.zaber_spin_button_table.show()
        
		self.zaber_table.attach(self.zaber_spin_button_table,0,1,1,2,xoptions = False,\
					yoptions = False,xpadding = 2, ypadding = 2)

		self.zaber_home_all_button = gtk.Button('Home All')
		self.zaber_home_all_button.show()
		self.zaber_home_all_button.connect("clicked", self.zaber_home, 0)
		
		self.zaber_save_position_button = gtk.Button('Save all positions to file')
		self.zaber_save_position_button.connect("clicked",self.zaber_save_pos)
		self.zaber_save_position_button.show()
		
		self.zaber_recall_position_button = gtk.Button('Recall all positions from file')
		self.zaber_recall_position_button.connect("clicked",self.zaber_recall_pos)
		self.zaber_recall_position_button.show()
		
                #create a table for buttons
		self.zaber_position_button_table = gtk.Table(1,6,False)
		self.zaber_position_button_table.show()
		
		self.zaber_position_button_table.attach(self.zaber_home_all_button,0,1,0,1,\
							xpadding = 2, ypadding = 2)
		self.zaber_position_button_table.attach(self.zaber_save_position_button,2,3,0,1,\
							xpadding = 2, ypadding = 2)
		self.zaber_position_button_table.attach(self.zaber_recall_position_button,3,4,0,1,\
							xpadding = 2, ypadding = 2)
		self.zaber_table.attach(self.zaber_position_button_table,0,2,2,3,\
					xoptions = False|True,yoptions = False|True,\
					xpadding = 2, ypadding = 2)

                #combo_box to choose ealing mount
		self.zaber_combo_box = gtk.combo_box_new_text()
		self.zaber_combo_box.show()
		self.zaber_combo_box.set_wrap_width(1)
		for i in range(6):
			if i<5:
				self.zaber_combo_box.append_text('Offset IR%d' % (i+1))
			else:
				self.zaber_combo_box.append_text('Closure BC')
			
		self.zaber_combo_box.set_active(self.actuator-1)
		self.zaber_combo_box.connect("changed",self.zaber_menu_changed)
			
                #create another table
		self.zaber_direct_move_table = gtk.Table(2,2,False)
		self.zaber_direct_move_table.show()

                #text box to hold position
		self.zaber_position_entry = gtk.Entry(max=6)
		self.zaber_position_entry.set_text(str(self.zab.absolute_position(self.actuator, 1)))
		self.zaber_position_entry.show()
		
		self.zaber_move_to_position_button = gtk.Button('Move to')
		self.zaber_move_to_position_button.connect("clicked",self.zaber_move_to_pos)
		self.zaber_move_to_position_button.show()
		
		self.zaber_refresh_position_button = gtk.Button('Refresh')
		self.zaber_refresh_position_button.connect("clicked",self.zaber_refresh_pos)
		self.zaber_refresh_position_button.show()
		
		self.zaber_direct_move_table.attach(self.zaber_combo_box,0,1,0,1,\
						    xoptions = False|True,yoptions = False|True,\
						    xpadding = 2, ypadding = 2)
		self.zaber_direct_move_table.attach(self.zaber_position_entry,0,1,1,2,\
						    xoptions = False|True,yoptions = False|True,\
						    xpadding = 2, ypadding = 2)
		self.zaber_direct_move_table.attach(self.zaber_move_to_position_button,1,2,0,1,\
						    xpadding = 2, ypadding = 2)
		self.zaber_direct_move_table.attach(self.zaber_refresh_position_button,1,2,1,2,\
						    xpadding = 2, ypadding = 2)
		
		self.zaber_table.attach(self.zaber_direct_move_table,1,2,1,2,xoptions = False|True,\
					yoptions = False|True,xpadding = 2, ypadding = 2)

            

        #################  Zaber functions ###############

        #move zaber function
	def zaber_move(self,widget,direction,actuator):
		print direction, actuator
		zz = long(self.zaber_z_spin_button.get_value())
		act = [{'IN':[1, -10*zz], 'OUT':[1,  10*zz]},
		       {'IN':[2, -10*zz], 'OUT':[2,  10*zz]},
		       {'IN':[3, -10*zz], 'OUT':[3,  10*zz]},
		       {'IN':[4, -10*zz], 'OUT':[4,  10*zz]},
		       {'IN':[5, -10*zz], 'OUT':[5,  10*zz]},
		       {'IN':[6, 10*zz], 'OUT':[6,  -10*zz]}]
		self.zab.move_relative(act[actuator-1][direction][0], 1, act[actuator-1][direction][1])
		self.zaber_refresh_pos(0)
            
        #functions for saving current position to a file
	def zaber_save_pos(self,widget):		
		self.zaber_save_filew = gtk.FileSelection('Save all positions to file')
		self.zaber_save_filew.connect("destroy",lambda w: self.zaber_save_filew.destroy())
		self.zaber_save_filew.ok_button.connect("clicked",self.zaber_file_save_action)
		self.zaber_save_filew.cancel_button.connect("clicked",lambda w: \
							self.zaber_save_filew.destroy())
		self.zaber_save_filew.show()

        #function to actually do the filesaving
        def zaber_file_save_action(self,widget):
		self.zab.save_position(self.zaber_save_filew.get_filename(),self.m)
		print "save info to %s" % self.zaber_save_filew.get_filename()
		self.zaber_save_filew.destroy()
	       
        #functions for recalling position from a file
        def zaber_recall_pos(self,widget):
		self.zaber_recall_filew = gtk.FileSelection('Recall all positions from file')
		self.zaber_recall_filew.connect("destroy",lambda w: self.zaber_recall_filew.destroy())
		self.zaber_recall_filew.ok_button.connect("clicked",self.zaber_file_recall_action)
		self.zaber_recall_filew.cancel_button.connect("clicked",\
							      lambda w: self.zaber_recall_filew.destroy())
		self.zaber_recall_filew.show()
	       
        #function that actually recalls the file
        def zaber_file_recall_action(self,widget):
		self.zab.recall_position(self.zaber_recall_filew.get_filename(),self.m)
		print "recalled info from %s" % self.zaber_recall_filew.get_filename()
		self.zaber_recall_filew.destroy()		
	       
        def zaber_home(self,widget,actuator):
		print 'actuator = ', actuator	
		self.zab.home(actuator, 1)
		self.zaber_refresh_pos(0)

	def zaber_read_file(self,actuator, filename):
		file = open(filename)
		text = file.read()
		positions = text.split("\n")
		self.zab.move_absolute(actuator, 1, long(positions[actuator-1]))
		self.zaber_refresh_pos(0)
		
        #function for combo box to enter/see exact postion of ealing actuator:
	def zaber_menu_changed(self,combo_box):
		act = [1, 2, 3, 4, 5, 6]
		self.actuator = act[combo_box.get_active()]
	       
                #insert function to set text on position box
		self.zaber_refresh_pos(0)

	def zaber_move_to_pos(self,widget):
		self.zab.move_absolute(self.actuator, 1, long(self.zaber_position_entry.get_text()))
        
	def zaber_refresh_pos(self,widget):
		self.zaber_position_entry.set_text(str(self.zab.absolute_position(self.actuator, 1)))



################################################################################################################################################################
#############################################################Button Callback Functions#########################################################################
################################################################################################################################################################



	# Sets label on picomotor selection and Loads control of selected picomotor.
	def mounts_callback(self, widget, num):	#Beginning of function definition num is the number of the mounts that has been 						selected and is passed into the function
		
		
		self.window.show_all()								#Sets everything as visible
		picoData.label = picoData.picoId.field('picoId')[num*2]				#Retrieves the name of the selected 													mount from the lookup table in 													picoData.py
		self.entry[0].set_text(picoData.label)						#Sets the selected picomotor label to 													the name of the selected mount
		picoName = picoData.label							#Sets picoName variable equal to the 													retrived name of the mount
		picoIP = picoData.getFieldValue(picoData.picoId, 'IP', 'picoId', picoName)	#Retrives the IP adress of the 													selected pico from the lookup table in 													picoData.py
# JDM               
		
        	index, = picoData.picoId.field('picoId').match(picoName)			#Puts the values of the two picomotors 													associated with a particular mount 													into the array index as they appear in 													the look uptable in picoData.py
        	nAxis = len(index)								#nAxis is the number of axis present 													in this application it could be 												listed, but this finds the number of 													axis by looking at the number of 													entries in index
		self.index = index								#Makes the index array global 
		print index		
		self.xpos = picoData.location[index[0]]						#Updates the x postion for the 													selected mount as it appears in the 													storage array in picoData.py
		self.ypos = picoData.location[index[1]]						#Updates the y postion for the 													selected mount as it appears in the 													storage array in picoData.py
		self.entry[4].set_text(str(picoData.location[index[0]]))			#Updates the x postition text entry 													upon selection of a new mount to the 													position values for that mount stored 													in picoData.py
		self.entry[3].set_text(str(picoData.location[index[1]]))			#Updates the x postition text entry 													upon selection of a new mount to the 													position values for that mount stored 													in picoData.py
		self.plus_scales = picoData.picoScales.field('plus_scale')[index]
             	self.minus_scales = picoData.picoScales.field('minus_scale')[index]
                self.ratio_m_p = self.minus_scales*1.0/self.plus_scales
                
		self.driver = picoData.picoId.field('driver')[index]				#Loads the drivers names that the 													selected mount's picos reside on
		self.motor = picoData.picoId.field('motor')[index]				#Loads the motors that the selected 													mount's picos are on (driver channel)
		self.steps = PicoLib.array(self.plus_scales)						#This sets the default step size that 													loads each time a new mount is selected
		print "picoName = ", picoName							#Prints  selected mount name 
        	print "available axis: ", picoData.picoId.field('axis')[index]			#Prints the axes that are availabel X&Y
		print "picoIP = ", picoIP							#Prints the IP Adress of the picos
		print self.motor								#Prints the motor that eh picos are on

		# Intialization of the telnet connection with the picoMotor
        	if picoData.select_Flag == False:						#Checks to see if a mount has 													previously been selected protecting 													against trying to make multiple telnet 													connections, only one may be made
		        picoLowLevel.PicoControl.__init__(self, picoIP)				#Opens telnet as per existing 													picoLowLevel.py function
      			print "self.tn.host = ", self.tn.host					#Prints host name of telnet connection
		for i in range(nAxis):								#Allows useable axis to be addressed
	        	self.SetVelocity(self.driver[i], self.motor[i], 2000)			#Sets a default velocity to the picos
		self.entry[1].set_text(str(self.steps[0]*1.0/self.plus_scales[0]))					#Sets X default step size
		self.entry[2].set_text(str(self.steps[1]*1.0/self.plus_scales[1]))					#Sets Y default step size
		picoData.select_Flag = True							#Sets flag that mount has been 													selected thus telnet has been opened
		self.update_step_callback(widget, 'X')						#Forces update of x step size as if 													enter has been pressed
		self.update_step_callback(widget, 'Y')						#Forces update of y step size as if 													enter has been pressed

	# Step Size Double Button Callback
	def step_button_callback(self, widget, increment):		#Initializes function, increment passed from button, 1/2x or 2x
		if increment == 'half':					#This part deals with halving the step size
			self.steps[0] = self.steps[0] * .5		#Halves X step size
			self.steps[1] = self.steps[1] * .5		#Halves Y step size
			self.entry[1].set_text(str(self.steps[0]*1.0/self.plus_scales[0]))	#Updates X step size entry on control panel
			self.entry[2].set_text(str(self.steps[1]*1.0/self.plus_scales[1]))	#Updates Y step size entry on control panel

		if increment == 'double':				#This part deals with doubling the step size
			self.steps = self.steps * 2			#More effectively doubles the step size than halving above
			self.entry[1].set_text(str(self.steps[0]*1.0/self.plus_scales[0]))	#Updates X step size entry on control panel
			self.entry[2].set_text(str(self.steps[1]*1.0/self.plus_scales[1]))	#Updates Y step size entry on control panel
		self.update_step_callback(widget, 'X')			#Forces callback for X step size-like pressing enter in the box
		self.update_step_callback(widget, 'Y')			#Forces callback for Y step size-like pressing enter in the box
		#self.xpos = picoData.location[index[0]]			#Sets X position of internal variable equal with picoData
		#self.ypos = picoData.location[index[1]]			#Sets Y position of internal variable equal with picoData





#################################################################################################################################################################
##############################################GTK Functions For Control Buttons################################################################################
#################################################################################################################################################################

	# Create icons for mounts to place on buttons
	"""def create_mount_buttons(self):					#Initializes function, no variables passed in
		mount_buttons = []					#Creates empty array
		for n in range(num/2):					#Runs through 12 times one for each mount in the system
			mount_buttons.append(gtk.Button())		#Adds a new entry to the array
			if n < 6:					#For the first six icons
				image = mounts.makeIcon('right')	#They face right
			else:						#The rest
				image = mounts.makeIcon('left')		#Well they face left
			mount_buttons[n].add(image)			#Now each icon is put onto a button!
		return mount_buttons					#Finally the array of buttons is returned.Yay!

"""
	# Create icons for arrows to place on buttons
	def create_control_buttons(self):								#Initializes function, no variables passed in
		control_buttons = []								#Empty array is created
		
		#Code was changed from each colored arrow having it's own button to only four buttons on which different icons would be placed, code structure 			follows the pattern of creating a button for each icon, but has been edited so that only four buttons are created and global icons are 			created, kind of silly really

		control_buttons.append(gtk.Button())						#Creates button #1			
		self.leftblack = icons.makeIcon('leftb')					#Creates black arrow pointing left
		control_buttons.append(gtk.Button())						#Creates button #2
		self.rightblack = icons.makeIcon('rightb')					#Creates black arrow pointing right
		control_buttons.append(gtk.Button())						#Creates button #3
		self.upblack = icons.makeIcon('upb')						#Creates black arrow pointing up
		control_buttons.append(gtk.Button())						#Creates button #4
		self.downblack = icons.makeIcon('downb')					#Creates black arrow pointing dow
		self.leftred = icons.makeIcon('leftr')						#Creates red arrow pointing left
		self.rightred = icons.makeIcon('rightr')					#Creates red arrow pointing right
		self.upred = icons.makeIcon('upr')						#Creates red arrow pointing up
		self.downred = icons.makeIcon('downr')						#Creates red arrow pointing down
		self.leftyellow = icons.makeIcon('lefty')					#Creates yellow arrow pointing left
		self.rightyellow = icons.makeIcon('righty')					#Creates yellow arrow pointing right
		self.upyellow = icons.makeIcon('upy')						#Creates yellow arrow pointing up
		self.downyellow = icons.makeIcon('downy')					#Creates yellow arrow pointing down
		control_buttons.append(gtk.Button())
		self.plusblack = icons.makeIcon('plusb')
		control_buttons.append(gtk.Button())
		self.minusblack = icons.makeIcon('minusb')
		self.minusyellow = icons.makeIcon('minusy')
		self.minusred = icons.makeIcon('minusr')
		self.plusyellow = icons.makeIcon('plusy')
		self.plusred = icons.makeIcon('plusr')




		return control_buttons								#Returns the array of 6 buttons
	






	# Updates step size when enter is pressed in the text box	
	def update_step_callback(self, widget, axis):						#Initialization of the function
		if axis == 'X':									#This group of if statements gets which axis is input and
			pointer = 1								#assigns a variable used later to reflect which axis is entered
			tempscale = self.plus_scales[0]
		if axis == 'Y':
			pointer = 2
			tempscale = self.plus_scales[1]
		text = (self.entry[pointer].get_text())						#Gets the text from the text box of the specified axis
		test = self.character_test(text)						#Runs the text in the text box through a function that tests 													for the prescence of letters and returns a true or false
		if test == False:								#If no letters are found, false is returned
			ntext = int(float(text)*tempscale)					#The text from the text box is brought in as a sting, this 													converts the string to a group of integer
			if 0 < ntext <= 4000 :							#Checks if the value  of the text box entry falls within range
				if axis == 'X':							#Checks axis
					

			#Here,Yellow arrows on the X axis buttons are turned to black arrows
					if self.xcol == 'yellow':			      #Checks color
						self.statusbar.set_text("Status: No Errors.") #Updateds status to reflect arrow color
						self.control_buttons[0].remove(self.leftyellow) #Removes yellow arrow pointing left
						self.control_buttons[1].remove(self.rightyellow)#Removes yellow arrow pointing right
						self.control_buttons[0].add(self.leftblack)     #Adds black arrow pointing left
						self.control_buttons[1].add(self.rightblack)    #Adds black arrow pointing right
						self.leftblack.show()			      #Makes black arrow left icon visible
						self.rightblack.show()			      #Makes black arrow right icon visible
						self.xcol = 'black'			      #Updates X axis color marker
			#Here, Red arrows on the X axis buttons are turned to black arrows
					if self.xcol == 'red':				      #Checks color
						self.statusbar.set_text("Status: No Errors.") #Updates status to reflect arrow color
						self.control_buttons[0].remove(self.leftred)    #Removes red arrow pointing left
						self.control_buttons[1].remove(self.rightred)   #Removes red arrow pointing right
						self.control_buttons[0].add(self.leftblack)     #Adds black arrow pointing left
						self.control_buttons[1].add(self.rightblack)    #Adds black arrow pointing right
						self.leftblack.show()			      #Makes black arrow left icon visible
						self.rightblack.show()			      #Makes black arrow right icon visible
						self.xcol = 'black'			      #Updates X axis color marker
						
				if axis == 'Y':							#Checks axis
			# Here, Yellow arrows on the Y axis buttons are turned to black 
					if self.ycol == 'yellow':				#Checks color
						self.statusbar.set_text("Status: No Errors.")	#Updates status to reflect arrow color
						self.control_buttons[2].remove(self.upyellow)	#Removes yellow arrow pointing up
						self.control_buttons[3].remove(self.downyellow)	#Removes yellow arrow pointing down
						self.control_buttons[2].add(self.upblack)		#Adds black arrow pointing up
						self.control_buttons[3].add(self.downblack)	#Adds black arrow pointing down
						self.upblack.show()				#Makes black arrow up visible
						self.downblack.show()				#Makes black arrow down visible
						self.ycol = 'black'				#Updates Y axis color marker
			#Here, Red arrows on the y axis buttons are turned to black
					if self.ycol == 'red':					#Checks color
						self.statusbar.set_text("Status: No Errors.")	#Updates status to reflect arrow color
						self.control_buttons[2].remove(self.upred)	#Removes red arrow pointing up
						self.control_buttons[3].remove(self.downred)	#Removes red arrow pointing down
						self.control_buttons[2].add(self.upblack)		#Adds black arrow pointing up
						self.control_buttons[3].add(self.downblack)	#Adds black arrow pointing down
						self.upblack.show()				#Makes black arrow up visible
						self.downblack.show()				#Makes black arrow down visible
						self.ycol = 'black'				#Updates Y axis color marker

				newsteps = self.entry[pointer].get_text()			#Value is retrieved from entry box
				self.steps[pointer-1] = int( float(newsteps)*tempscale)				#Now text entry is made new step size
				print "New step size: %d\n" % self.steps[pointer-1]		#Prints new step size to command window
			# Else catches instances in which entry is out of range
			else:	
				if axis == 'X':							#Checks axis
			#Here, black arrows on the X axis are turned to red
					if self.xcol == 'black':				#Checks color
						self.statusbar.set_text("Status: Step Entry is Out of Range.")#Updates status to 															    reflect arrow color
						self.control_buttons[0].remove(self.leftblack)	#Removes black arrow pointing left
						self.control_buttons[1].remove(self.rightblack)	#Removes black arrow pointing right
						self.control_buttons[0].add(self.leftred)		#Adds red arrow pointing left
						self.control_buttons[1].add(self.rightred)	#Adds red arrow pointing right
						self.leftred.show()				#Makes red arrow left visible
						self.rightred.show()				#Makes red arrow right visible
						self.xcol = 'red'				#Updates X axis color marker
			#Here, yellow arrows on the X axis are turned to red
					if self.xcol == 'yellow':				#Checks color
						self.statusbar.set_text("Status: Step Entry is Out of Range.")#Updates status to 															    reflect arrow color
						self.control_buttons[0].remove(self.leftyellow)	#Removes yellow arrow pointing left
						self.control_buttons[1].remove(self.rightyellow)	#Removes yellow arrow pointing right
						self.control_buttons[0].add(self.leftred)		#Adds red arrow pointing left
						self.control_buttons[1].add(self.rightred)	#Adds red arrow pointing right
						self.leftred.show()				#Makes red arrow left visible
						self.rightred.show()				#Makes red arrow right visible
						self.xcol = 'red'				#Updates X axis color marker

				if axis == 'Y':							#Checks axis	
			#Here, black arrows on the Y axis are turned to red		
					if self.ycol == 'black':				#Checks color
						self.statusbar.set_text("Status: Step Entry is Out of Range.")#Updates status to 															    reflect arrow color
						self.control_buttons[2].remove(self.upblack)	#Removes black arrow pointing up
						self.control_buttons[3].remove(self.downblack)	#Removes black arrow pointing down
						self.control_buttons[2].add(self.upred)		#Adds red arrow pointing up
						self.control_buttons[3].add(self.downred)		#Adds red arrow pointing down
						self.upred.show()				#Makes red up arrow visible
						self.downred.show()				#Makes red down arrow visible
						self.ycol = 'red'				#Updates Y axis color marker
			#Here, yellow arrows on the Y axis are turned to red
					if self.ycol == 'yellow':				#Checks color
						self.statusbar.set_text("Status: Step Entry is Out of Range.")#Updates status to 															    reflect arrow color
						self.control_buttons[2].remove(self.upyellow)	#Removes yellow arrow pointing up
						self.control_buttons[3].remove(self.downyellow)	#Removes yellow arrow pointing down
						self.control_buttons[2].add(self.upred)		#Adds red arrow pointing up
						self.control_buttons[3].add(self.downred)		#Adds red arrow pointing down
						self.upred.show()				#Makes red arrow up visible
						self.downred.show()				#Makes red arrow down visible
						self.ycol = 'red' 				#Updates Y axis color marker
			# Else catches instances in which letters are found
	   	else:	
			if axis == 'X':								#Checks axis
			#Here, black arrows on the X axis are turned to red
				if self.xcol == 'black':					#Checks Color
					self.statusbar.set_text("Status: Step Entry Contains Letters!.")#Updates status to 															reflect arrow color
					self.control_buttons[0].remove(self.leftblack)		#Removes black arrow pointing left
					self.control_buttons[1].remove(self.rightblack)		#Removes black arrow pointing right
					self.control_buttons[0].add(self.leftred)			#Adds red arrow pointing left
					self.control_buttons[1].add(self.rightred)		#Adds red arrow pointing right
					self.leftred.show()					#Makes red arrow left visible
					self.rightred.show()					#Makes red arrow right visible
					self.xcol = 'red'					#Updates X axis color marker
			#Here, yellow arrow on the X axis are turned to red
				if self.xcol == 'yellow':					#Checks Color
					self.statusbar.set_text("Status: Step Entry Contains Letters!.")#Updates status to 															reflect arrow color
					self.control_buttons[0].remove(self.leftyellow)		#Removes yellow arrow pointing left
					self.control_buttons[1].remove(self.rightyellow)		#Removes yellow arrow pointing right
					self.control_buttons[0].add(self.leftred)			#Adds red arrow pointing left
					self.control_buttons[1].add(self.rightred)		#Adds red arrow pointing right
					self.leftred.show()					#Makes red arrow left visible
					self.rightred.show()					#Makes red arrow right visible
					self.xcol = 'red'					#Updates X axis color marker
				
			if axis == 'Y':								#Checks axis
			#Here, black arrows on the Y axis are turned to red
				if self.ycol == 'black':					#Checks color
					self.statusbar.set_text("Status: Step Entry Contains Letters!.")#Updates status to 															reflect arrow color
					self.control_buttons[2].remove(self.upblack)		#Removes black arrow pointing up
					self.control_buttons[3].remove(self.downblack)		#Removes black arrow pointing down
					self.control_buttons[2].add(self.upred)			#Adds red arrow pointing up
					self.control_buttons[3].add(self.downred)			#Adds red arrow pointing down
					self.upred.show()					#Makes red arrow up visible
					self.downred.show()					#Makes red arrow down visible
					self.ycol = 'red'					#Updates Y axis color marker
		#Here, yellow arrow on the Y axis are turned to red
				if self.ycol == 'yellow':					#Checks color
					self.statusbar.set_text("Status: Step Entry Contains Letters!.")#Updates status to 															reflect arrow color
					self.control_buttons[2].remove(self.upyellow)		#Removes yellow arrow pointing up
					self.control_buttons[3].remove(self.downyellow)		#Removes yellow arrow pointing down
					self.control_buttons[2].add(self.upred)			#Adds red arrow pointing up
					self.control_buttons[3].add(self.downred)			#Adds red arrow pointing down
					self.upred.show()					#Makes red up arrow visible
					self.downred.show()					#Makes red down arrow visible
					self.ycol = 'red' 					#Updates Y axis color marker


	#This function checks each time there is any change in a text entry box whether or not the entry meets the criteria of  the range from 0 - 4000 as well as the absence of letters.

	# Callback for changed step size
	def changed(self, widget, which):							#Initialization of the function
		if which == 'X':								#Folllowing group of ifs checks which
			pointer = 1								#axis is being checked and specifies it
			tempscale = self.plus_scales[0]
		if which == 'Y':								#for use in the function
			pointer = 2
			tempscale = self.plus_scales[1]
		text = (self.entry[pointer].get_text())						#Text from box is brought in
		test = self.character_test(text)						#Text is checked for letters
		if self.firsttime == False:							#During the program initialization there is a sequence that causes a step size error, this flag is used to avoid the error by not allowing the change that would be made if allowed to moniter the set-up sequence for the step size / entry box.

			#Only entries without letters are evaluated in this part
			if test == False:							#Confirms letter absence 	
				if which == 'X':						#Checks axis
					flag = 1						#Variable for avoiding error mentioned 													above
			#Here, black arrows on the X axis are turned to yellow
					if self.xcol == 'black':				#Color is checked
						self.statusbar.set_text("Status: Step size is not up to date.")#Status is 														     updated to match 															     arrow color 
						self.control_buttons[0].remove(self.leftblack)	#Removes black arrow pointing left
						self.control_buttons[1].remove(self.rightblack)	#Removes black arrow pointing right
						self.control_buttons[0].add(self.leftyellow)	#Adds yellow arrow pointing left
						self.control_buttons[1].add(self.rightyellow)	#Adds yellow arrow pointing right
						self.leftyellow.show()				#Makes yellow left arrow visible
						self.rightyellow.show()				#Makes yellow right arrow visible
						self.xcol = 'yellow'				#Updates X axis color marker

			#Here, red arrows on the X axis are turned to yellow
					if self.xcol == 'red':					#Color checked
						self.statusbar.set_text("Status: Step size is not up to date.")#Status is 														     updated to match 															     arrow color
						self.control_buttons[0].remove(self.leftred)	#Removes red arrow pointing left
						self.control_buttons[1].remove(self.rightred)	#Removes red arrow pointing right
						self.control_buttons[0].add(self.leftyellow)	#Adds yellow arrow pointing left
						self.control_buttons[1].add(self.rightyellow)	#Adds yellow arrow pointing right
						self.leftyellow.show()				#Makes yellow left arrow visible
						self.rightyellow.show()				#Makes yellow right arrow visible
						self.xcol = 'yellow'				#Updates X axis color marker

				elif which == 'Y':						#Checks axis
					flag = 1						#Variable for avoiging error mentioned 													above
			# Here, black arrows on the Y axis are turned to yellow
					if self.ycol == 'black':				#Color checked
						self.statusbar.set_text("Status: Step size is not up to date.")#Status is 														     updated to match 															     arrow color
						self.control_buttons[2].remove(self.upblack)	#Removes black arrow pointing up
						self.control_buttons[3].remove(self.downblack)	#Removes black arrow pointing down
						self.control_buttons[2].add(self.upyellow)	#Adds yellow arrow pointing up
						self.control_buttons[3].add(self.downyellow)	#Adds yellow arrow pointing down
						self.upyellow.show()				#Makes yellow up arrow visible
						self.downyellow.show()				#Makes yellow down arrow visible
						self.ycol = 'yellow'				#Updates Y axis color marker

			#Here, red arrows on the Y axis are turned to yellow
					if self.ycol == 'red':					#Color checked
						self.statusbar.set_text("Status: Step size is not up to date.")#Status is 														     updated to match 															     arrow color
						self.control_buttons[2].remove(self.upred)	#Removes red arrow pointing up
						self.control_buttons[3].remove(self.downred)	#Removes red arrow pointing down
						self.control_buttons[2].add(self.upyellow)	#Adds yellow arrow pointing up
						self.control_buttons[3].add(self.downyellow)	#Adds yellow arrow pointing down
						self.upyellow.show()				#Makes yellow up arrow visible
						self.downyellow.show()				#Makes yellow down arrow visible
						self.ycol = 'yellow'				#Updates Y axis color marker

			# Else catches instances containing letter
			else:
				if which == 'X':						#Axis is checked
			#Here, black arrows on the X axis are turned to red
					if self.xcol == 'black':				#Color checked
						self.statusbar.set_text("Status: Step Entry Contains Letters!.")#Status 															 is updated to 															match arrow color
						self.control_buttons[0].remove(self.leftblack)	#Removes black arrow pointing left
						self.control_buttons[1].remove(self.rightblack)	#Removes black arrow pointing right
						self.control_buttons[0].add(self.leftred)		#Adds red arrow pointing left
						self.control_buttons[1].add(self.rightred)	#Adds red arrow pointing right
						self.leftred.show()				#Makes red left arrow visible
						self.rightred.show()				#Makes red right arrow visible
						self.xcol = 'red'				#Updates X axis color marker

			#Here, yellow arrows on the X axis are turned to red
					if self.xcol == 'yellow':				#Color is checked
						self.statusbar.set_text("Status: Step Entry Contains Letters!.")#Status 																is updated to 															match arrow color
						self.control_buttons[0].remove(self.leftyellow)	#Removes yellow arrow pointing left
						self.control_buttons[1].remove(self.rightyellow)	#Removes yellow arrow pointing right
						self.control_buttons[0].add(self.leftred)		#Adds red arrow pointing left
						self.control_buttons[1].add(self.rightred)	#Adds red arrow pointing right
						self.leftred.show()				#Makes red left arrow visible
						self.rightred.show()				#Makes red left arrowvisible
						self.xcol = 'red'				#Updates X axis color marker 


				if which == 'Y':						#Checks axis
			#Here, black arrows on the Y axis are turned to red
					if self.ycol == 'black':				#Checks color
						self.statusbar.set_text("Status: Step Entry Contains Letters!.")#Status 														updated to match arrow color
						self.control_buttons[2].remove(self.upblack)	#Removes black arrow pointing up
						self.control_buttons[3].remove(self.downblack)	#Removes black arrow pointing down
						self.control_buttons[2].add(self.upred)		#Adds red arrow pointing up
						self.control_buttons[3].add(self.downred)		#Adds red arrow pointing down
						self.upred.show()				#Makes red up arrow visible
						self.downred.show()				#Makes red down arrow visible
						self.ycol = 'red'				#Updates Y axis color marker

			# Here, yellow arrows on the Y axis are turned to red
					if self.ycol == 'yellow':				#Color is checked
						self.statusbar.set_text("Status: Step Entry Contains Letters!.")#Status 														updated to match arrow color
						self.control_buttons[2].remove(self.upyellow)	#Removes yellow arrow pointing up
						self.control_buttons[3].remove(self.downyellow)	#Removes yellow arrow pointing down
						self.control_buttons[2].add(self.upred)		#Adds red arrow pointing up
						self.control_buttons[3].add(self.downred)		#Adds red arrow pointing down
						self.upred.show()				#Makes red up arrow visible
						self.downred.show()				#Makes red down arrow visible
						self.ycol = 'red'				#Updates Y axix color marker

		#Else takes care of error mentioned at top of function, simply counts off number of queries made during the set up sequence so the error is avoided.
		else: 
			if self.count >= 2:
				self.firsttime = False
			else:
				self.count = self.count + 1


			# This function calls to PicoLowLevel.py for telnet commands that move the pico motors

	# Moves picomotor at push of arrow button.
	def push_to_move_callback(self, widget, axis):						#Definition of Function, axis passed in
		print "WE ARE HERE2"
		if self.ycol == 'black':							#Statement only allows pico movement 													if color is black(denoting no errors)
			if axis == 'up':							#Up button pressed
				self.MoveRelative(self.driver[1],self.motor[1],-self.steps[1])	#Command function in PicoLowLevel that 													sends telnet command to move the 													picomotor
				self.ypos += self.steps[1]					#Updates internal pico position
				self.entry[3].set_text(str(self.ypos*1.0/self.plus_scales[1]))				#Updates pico position entry on 												control panel
				picoData.location[self.index[1]] = self.ypos			#Updates position in picoData.py
			if axis == 'down':							#Down button pressed
				self.MoveRelative(self.driver[1],self.motor[1],int(self.steps[1]*self.ratio_m_p[1]))	#Command function in PicoLowLevel that 													sends telnet command to move the 													picomotor
				self.ypos -= self.steps[1]					#Updates internal pico position
				self.entry[3].set_text(str(self.ypos*1.0/self.plus_scales[1]))				#Updates pico position entry on 												control panel
				picoData.location[self.index[1]] = self.ypos			#Updates position in picoData.py
		if self.xcol == 'black':							#Statement only allows pico movement 													if color is black(denoting no errors)
			if axis == 'left':							#Left button pressed
				self.MoveRelative(self.driver[0],self.motor[0],int(self.steps[0]*self.ratio_m_p[0]))	#Command function in PicoLowLevel that 													sends telnet command to move the 													picomotor
				self.xpos -= self.steps[0]					#Updates internal pico position
				self.entry[4].set_text(str(self.xpos*1.0/self.plus_scales[0]))				#Updates pico position entry on 												control panel
				picoData.location[self.index[0]] = self.xpos			#Updates position in picoData.py
			if axis == 'right':							#Right button pressed
				self.MoveRelative(self.driver[0],self.motor[0], -self.steps[0])	#Command function in PicoLowLevel that 													sends telnet command to move the 													picomotor
				self.xpos += self.steps[0]					#Updates internal pico position
				self.entry[4].set_text(str(self.xpos*1.0/self.plus_scales[0]))				#Updates pico position entry on 												control panel			
				picoData.location[self.index[0]] = self.xpos			#Updates position in picoData.py




	#Test that checks to see if there are letters in a string, or well, I guess it just checks that there isn't any thing thats not a number.
	def character_test(self, string):							#Initialization of function, passes in a string
		i=0										#Count variable
		flag = False									#False unles otherwise found
		while i <= len(string):								#While loop goes thought the entire length of the string
			if string[i-1:i] == "0":						#Looks at a specific location in the sdtring, funny colonization 													specifes current looking position
				flag = False							#Kinda usless to re-assert this
			elif string[i-1:i] == "1":
				flag = False
			elif string[i-1:i] == "2":
				flag = False
			elif string[i-1:i] == "3":
				flag = False
			elif string[i-1:i] == "4":
				flag = False
			elif string[i-1:i] == "5":
				flag = False
			elif string[i-1:i] == "6":
				flag = False
			elif string[i-1:i] == "7":
				flag = False
			elif string[i-1:i] == "8":
				flag = False
			elif string[i-1:i] == "9":
				flag = False
			else:
				flag = True
			i=i+1	
		return flag									#Returns True-has letters or False-no letters



	#This function opens a window when you click on zero all in the menu, it asks whether you want to do it or not

	def Zero_or_No(self,widget):								#Initializes window function
        	self.qwindow = gtk.Window(gtk.WINDOW_TOPLEVEL)					#Creates a new top level window
        	self.qwindow.set_title(" ")							#I gave it no title
        	self.qwindow.set_border_width(10)						#Just sets the border width of the window
		table = gtk.Table(7,5 , True)							#Creates a table 7 rows, 5 cols, all cell same size
		label = gtk.Label("Are you sure you want to zero all of the postions?") 	#Creates label
		table.attach(label, 0,7,2,3,0,0,0,0)						#Attaches label to table
		label.show()									#Makes the label visible on the window
		# Yes Button
		yes = gtk.Button("Zero Them")							#Confirmation button is created
		table.attach(yes,2,3,3,4,0,0,0,0)						#Attaches confirmation button to table
		yes.show()									#Makes confirmation button visible on the window
		yes.connect("clicked",self.zeroall_callback, 'yes')				#Connects a click on the confirmation button to 												callback
		# No Button
		close = gtk.Button("No")							#No button is created
		table.attach(close,4,5,3,4,0,0,0,0)						#No button is attached to the table
		close.show()									#No button made visible on the window
		close.connect("clicked",self.zeroall_callback, 'no')				#Connects a click on the no button to the callback
		table.show()									#Makes the no button visible on the window
		self.qwindow.add(table)								#Adds the table onto the window
        	self.qwindow.show()								#Makes the window visible
		
#################################################################################################################################################################
###############################################################Finalization of Program#########################################################################
#################################################################################################################################################################


	def main(self):
		gtk.main()		

if __name__ == "__main__":
	home=home()	
	home.main()



