#common.py:
import numarray as na

host  = '192.168.3.136'
port = 60000

## rmg/fb alignment stuff ######################################################################

# this will be replaced by obtaining the number of beams from champ server
# see ../FTGui/IRCamCommands.py: data = self.getStructFromRT('SP',cstruct)
number_beams = 6

#####################
## config for 4 beams
#####################

# aligment steps
step_4 = [1,2,3,4,5,6,7,8,9,10,11,12]

# active beam
beam_4 = [1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 4]

# spot name
spot_name_4 =  ['L1', 'R2', 'L2', 'R3', 'R2', 'L3', 'R4', 'R3', 'L4', 'R1', 'R4', 'L1']

# spot quadrant
spot_quadrant_4 = [2, 1, 4, 1, 1, 1, 4, 1, 3, 3, 4, 2]

# position within the quadrant
position_index_4 = [1, 2, 1, 4, 2, 1, 4, 4, 1, 4, 4, 1]   
position_name_4 = ['Bottom Left', 'Bottom Right', 'Top Left', 'Top Right']

# pico name
pico_name_4 = ['Dicroic 1 (or T3H)', 'T2H', 'Dicroic 2 (or T3M)', 'T2M','BC1-2','Dicroic 3 (or T4H)','T1L','BC2-3','Dicroic 4 (T4M)','T2L','BC3-4','BC6-1']

# comment
additional_info_4 = ['dude ...', 'top spot','top spot', 'bottom spot','top spot','bottom spot','top spot','bottom spot','top spot','top spot','top spot','bottom spot']

# x and y coordinates of target spot location
xtarget_4 = [1,6,1,6,6,1,6,6,1,6,6,1]
ytarget_4 = [1,1,1,6,1,1,6,6,1,6,6,1]

# automatic selection of proper spot in channel flux display
# order in channel selection is "L1","R1","L2","R2","L3","R3","L4","R4","L5","R5","L6","R6"
#                               0     1    2    3    4    5    6    7    8    9    10   11
spot_number_4 = [0, 3, 2, 5, 3, 4, 7, 5, 6, 1, 7, 0]

#####################
## config for 6 beams
#####################

# aligment steps
step_6 = [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18]

# active beam
beam_6 = [1,1,2,2,2,3,3,3,4,4,4,5,5,5,6,6,6,6]

# spot name
spot_name_6 =  ['L1','R2','L2','R3','R2','L3','R4','R3','L4','R5','R4','L5','R6','R5','L6','R1','R6','L1']

# spot quadrant
spot_quadrant_6 = [2,1,4,1,1,1,4,1,3,2,4,3,2,2,4,3,2,2]

# position within the quadrant
position_index_6 = [1,2,1,4,2,1,4,4,1,2,4,3,4,2,3,4,4,1]   
position_name_6 = ['Bottom Left', 'Bottom Right', 'Top Left', 'Top Right']

# pico name
pico_name_6 = ['Dicroic 1 (or T3H)', 'T2H', 'Dicroic 2 (or T3M)', 'T2M','BC1-2','Dicroic 3 (or T4H)','T1L','BC2-3','Dicroic 4 (T4M)','T1H','BC3-4','Dichroic 5','T1M','BC4-5','Dichroic 5','T2L','BC5-6','BC6-1']

# comment
additional_info_6 = ['top spot','top spot','top spot','bottom spot','top  spot','bottom  spot','top  spot','bottom  spot','top  spot','bottom  spot','top  spot','brightest spot (right)','should be clean','bottom  spot','should be clean','top  spot','should be clean','???']

# x and y coordinates of target spot location
xtarget_6 = [1,6,1,6,6,1,6,6,1,6,6,1,6,6,1,6,6,1]
ytarget_6 = [1,1,1,6,1,1,6,6,1,1,6,6,6,1,6,6,6,1]

# automatic selection of proper spot in channel flux display
# order in channel selection is "L1","R1","L2","R2","L3","R3","L4","R4","L5","R5","L6","R6"
#                               0     1    2    3    4    5    6    7    8    9    10   11
spot_number_6 = [0, 3, 2, 5, 3, 4, 7, 5, 6, 9, 7, 8, 11, 9, 10, 1, 11, 0]

# shutter index (shutter.cfg from TtB) - obsolete
# shutter_index = [3,3,4,4,4,5,5,5,6,6,6,6]

## end alignment stuff ######################################################################


status1 = 9
status2 = 9

# makes sure these faults match the defaults in ircam commands or there will be
# mismatch between values!
rows = 16
cols = 16
roff = 8 #5   #7
coff = 20 #20  #9

framesPerReset=21
numberOfFrames=42

dataready1 = 0
dataready2 = 0
myArray = na.zeros((rows, cols), type=na.Float32)
fluxArray = na.zeros((12,numberOfFrames), type=na.Float32)
psArray = na.zeros((rows/2, 1+cols/2), type=na.Float32)
fmArray = na.zeros((6,6), type=na.Float32)
#fm peaks: 4 quads (UR,UL,BL,BR), x,y,peak,Fraction in peak,total counts
fmPeaks = na.zeros((4,5), type=na.Float32)

fmFluxArray = na.zeros((100,4),type=na.Float32)

gdtInfo = na.zeros(7, type=na.UInt32)
delayLinesOffsets = na.zeros(6, type=na.Float64)
updatedOffsets = na.zeros(6, type=na.Float64)
weights = na.zeros(6, type=na.Float32)
opds  = na.zeros(6, type=na.Float32)
